package paduainterface;
// Java packages
import java.io.*;


public class ActiveHistory{
 /* ------ FIELDS ------ */
    private MoveNode startMoveList = null;	//the first move in the list
    //private MoveNode currentMove = null;	//the current move in the list

    /* ------ CONSTRUCTORS ------ */
    /*Default constructor*/    	
    public ActiveHistory() {}

    /*------ Methods ------*/
    //add move to the end of the list
    protected void insertRuleintoActiveHistory(short playerGoal, Move move) {  
	// Create new node
	MoveNode newNode = new MoveNode(playerGoal, move);
	// Empty list situation
	if (startMoveList == null) {
	    startMoveList = newNode;
         }
	 else{//add the new move to the tail
		MoveNode index = startMoveList;
		while (index.next != null)
		  index = index.next;
		index.next = newNode; 
	  }
      }

    //search for a move in the list
    protected boolean search(short playerGoal, Move move){
        return search(playerGoal, move, startMoveList);
    }
    protected boolean search(Move move){
	return search(move, startMoveList);
    }
    protected boolean search(RuleNode rule){
	return search(rule, startMoveList);
    }

    private boolean search(short playerGoal, Move move, MoveNode moveList){
	boolean found = false;
	MoveNode linkMoveNode = moveList;
	MoveNode searchNode = new MoveNode(playerGoal, move);
	while ((linkMoveNode!=null)&&(!found)){
	  if(linkMoveNode.equals(playerGoal, move)) 
              found = true;
	  else
              linkMoveNode = linkMoveNode.next;	
	}
	return found;
    }
    private boolean search(Move searchMove, MoveNode moveList){
	boolean found = false;
	MoveNode linkMoveNode = moveList;
	while ((linkMoveNode!=null)&&(!found)){
	  if(Move.equals(linkMoveNode.getMove(), searchMove))
              found = true;
	  else
              linkMoveNode = linkMoveNode.next;	
	}
	return found;
    }
    private boolean search(RuleNode searchRule, MoveNode moveList){
	boolean found = false;
	MoveNode linkMoveNode = moveList;
	while ((linkMoveNode!=null)&&(!found)){
	  RuleNode rule = linkMoveNode.getMove().getContent();
	  if(RuleNode.equals(rule, searchRule))
              found = true;
	  else
              linkMoveNode = linkMoveNode.next;	
	}
	return found;
    }  
    
    /**returns the winner of the game*/
    private short getWinner(MoveNode moveList) { //true = pro
      if (moveList==null) return 0;
      else{
	 MoveNode linkMoveNode = moveList;
	 while (linkMoveNode.next != null)
	   linkMoveNode = linkMoveNode.next;
         return linkMoveNode.getPlayerGoal();
      }
    }  
    protected short getWinner() { //true = pro
        return this.getWinner(this.startMoveList);
    }  

    protected int dialogueLength(){
        if(this.startMoveList==null) return 0;
        int length = 1;
        MoveNode linkMove = this.startMoveList.next;
        while(linkMove!=null){
            length++;
            linkMove = linkMove.next;
        }
        return length;
    }
    //file procedures  
    /**opens the given file*/
  
    /**outputs*/
    protected String output(GameDictionary dictionary, boolean positiveGame){
        if(this.startMoveList==null)
            return "";
        return this.output(this.startMoveList, dictionary, positiveGame);
    }
    
    private String output(MoveNode moveList,GameDictionary dictionary, boolean positiveGame) {
        if(moveList==null)
            return "The dialogue was not that successfull:\n No rules were generated!\n";
        if(moveList.next==null){
            String output = "The dialogue was very short - one round only\n";
            output+= moveList.output(dictionary,positiveGame);
            return output;
        }
        String output = "";
        int round = 1;
        MoveNode linkMoveNode = moveList;
        // Loop through move list
        while (linkMoveNode.next != null) {
            output+= "Round : " + round + "\n";
            output+= linkMoveNode.output(dictionary, positiveGame);
            //output+="\n";
            round++;
            linkMoveNode = linkMoveNode.next;
        }
        output+= "Round : " + round + "\n";
        output+= linkMoveNode.output(dictionary, positiveGame);
        output+="-------------------------------------------------\n";
        output+=linkMoveNode.getSide(dictionary, positiveGame)+ " WINS THE GAME\n";
        output+="**********************************************************\n";
        return output;
    }
 }//end of the class
