package paduainterface;

/** this class implements the 6-legal moves in PADUA game*/
public class  Move {
   /* ------ FIELDS ------ */
   protected int type; //move type --> a digit from 1-6 represents the move type
   protected RuleNode contentRule; //the rule played

   /* ------ CONSTRUCTORS ------ */   
   /* Basic Constructor */
    public Move(int moveType, RuleNode content) {
	type=moveType;
	contentRule = content;
    }

    /* ------ SETTERS&GETTERS ------ */
    public void setContent(RuleNode content) {contentRule = content;}
    public void setType(int moveType) {type=moveType;}
    public RuleNode getContent() {return this.contentRule;}
    public int getType() {return this.type;}

    /* ------ OUTPUT ------ */
    public String output(GameDictionary dictionary){
      String moveString="";
      switch(this.type){
        case 1:
            moveString = "Proposes a new Rule: ";
            break;
        case 2:
            moveString = "Distinguishes the previous rule: ";
            break;
        case 3:
            moveString = "States that the previous rule has some Unwanted Consequences: ";
            break;
        case 4:
            moveString = "Proposes a Counter Rule: ";
            break;

        case 5:
            moveString = "Increases the Confidence of its previous move: ";
            break;
        case 6:
            moveString = "Withdraws the Unwanted Consequences of its previous move: ";
            break;
      }
      moveString = moveString + "\n";
      moveString = moveString + this.contentRule.output(dictionary);
      return moveString;
    }
    public String output(){
      String moveString="";
      switch(this.type){
        case 1:
            moveString = "Proposes a new Rule: ";
            break;
        case 2:
            moveString = "Distinguishes the previous rule: ";
            break;
        case 3:
            moveString = "States that the previous rule has some Unwanted Consequences: ";
            break;
        case 4:
            moveString = "Proposes a Counter Rule: ";
            break;

        case 5:
            moveString = "Increases the Confidence of its previous move: ";
            break;
        case 6:
            moveString = "Withdraws the Unwanted Consequences of its previous move: ";
            break;
      }
      moveString = moveString + "\n";
      moveString = moveString + this.contentRule.getString();
      return moveString;
    }
   /*--------EQUALS------------*/
    public static boolean equals(Move move1, Move move2) {
        if(move1.getType()==move2.getType()){
            RuleNode rule1 = move1.getContent();
            RuleNode rule2 = move2.getContent();
            if(RuleNode.equals(rule1, rule2)) return true;
            else return false;
        }
        else return false;
    }
}//end of class
