package paduainterface;


/** this class implements the 6-legal moves in PADUA game*/
public class  MoveNode {
   /* ------ FIELDS ------ */
   protected short playerGoal; //move player
   protected Move move;     
   MoveNode next = null; //Link to next node
   protected boolean isfirst=true;

   /* ------ CONSTRUCTORS ------ */
   /* Basic Constructor */
    public MoveNode(short movePlayer, Move playedMove) {
	this.playerGoal = movePlayer;
	this.move=playedMove;
    }

    /* ------ GETTERS ------ */
    protected Move getMove() {return this.move;}
    protected String getMoveString() {return this.move.output();}
    protected short getPlayerGoal() {return this.playerGoal;}
    /* ------ OUTPUT ------ */
    protected String output(GameDictionary dictionary, boolean positive){
        String output = this.getSide(dictionary, positive);
        output+=move.output(dictionary);
        return output;
    }
    protected String getSide(GameDictionary dictionary, boolean positive){
        if(positive){
            if(this.playerGoal == dictionary.getClassesAttributes()[0])
                return "Opponent : (" + dictionary.getClasses()[0] + ")\n";
            else
                return "Proponent : (" + dictionary.getClasses()[1] + ")\n";
        }
        else{
            if(this.playerGoal == dictionary.getClassesAttributes()[0])
                return "Proponent : (" + dictionary.getClasses()[0] + ")\n";
            else
                return "Opponent : (" + dictionary.getClasses()[1] + ")\n";
        }
    }
    
    /*--------EQUALS------------*/
    protected boolean equals(short nodePlayerGoal, Move nodeMove){
       if(this.playerGoal==nodePlayerGoal){
           if(Move.equals(this.move, nodeMove))
               return true;
           else return false;
       }
       else return false;
   }
   public static boolean equals(MoveNode moveNode1, MoveNode moveNode2) {
      if(moveNode1.getPlayerGoal()== moveNode2.getPlayerGoal()){
        Move move1 = moveNode1.getMove();
        Move move2 = moveNode2.getMove();
        if(Move.equals(move1,move2)) return true;
        else return false;
    }
    else return false;
   }
   public static boolean equalMoves(MoveNode moveNode1, MoveNode moveNode2) {
        Move move1 = moveNode1.getMove();
        Move move2 = moveNode2.getMove();
        if(Move.equals(move1,move2)) return true;
        else return false;    
   }   
   public static boolean equalRules(MoveNode moveNode1, MoveNode moveNode2) {
        RuleNode rule1 = moveNode1.getMove().getContent();
        RuleNode rule2 = moveNode2.getMove().getContent();
        if(RuleNode.equals(rule1,rule2)) return true;
        else return false;
   }
}//end of class
