/*
 * MoveType.java
 *
 * Created on 02 September 2008, 13:16
 *
 * Encapuslates the basic PADUA/PISA moves Types:
 * Propose new rule, counter rule, distinguish, unwanted consequences,
 * increase confidence and withdraw 
 * and the operations on these types
 * @author maya
 */
package paduainterface;
public final class MoveType {
    protected static final int PROPOSE_RULE =1;
    protected static final int DISTINGUISH =2;
    protected static final int UNWANTED_CONSEQUENCES =3;
    protected static final int COUNTER_RULE =4;
    protected static final int INCREASE_CONFIDENCE =5;
    protected static final int WITHDRAW_UNWANTED_CONSEQUENCES =6;
    
    /**Translates the move type value into string*/
    protected static String translate(int moveType){        
        switch(moveType){
            case 1:
                return "PROPOSE RULE";
            case 2:
                return "DISTINGUISH";
            case 3:
                return "UNWANTED CONSEQUENCES";
            case 4:
                return "COUNTER RULE";
            case 5:
                return "INCREASE CONFIDENCE";
            case 6:
                return "WITHDRAW UNWANTED CONSEQUENCES";     
            default:
                return "INVAILD MOVE TYPE";
        }     
    } 
    /**return true if the move type integer value is valid, false other wise*/
    protected static boolean vaildType(int moveType){        
        switch(moveType){
            case 1: case 2:case 3: case 4:case 5: case 6:
                return true;
            default:
                return false;
        }     
    } 
}
