package paduainterface;
public final class SubsetsGenerator
{
    private final short setSize, subsetsLevel;
    private boolean isFirst = true;
    private boolean hasNext;
    private short[] subset;
    
    /*----------------CONSTRUCTOR----------------------*/
    public SubsetsGenerator(short setSize, short level){
        this.setSize = setSize;
        this.subsetsLevel = level;

        this.subset = new short[subsetsLevel];
        for (short i = 0; i < subset.length; i++) {
            subset[i] = i;
        }
        this.hasNext = true;
    }

    public boolean HasNext()
    {
        return this.hasNext;
    }


    /**
     * Returns the next Level-subset of the N-set. Each combination is
     * represented by a short-integer array of size (Level) whose elements are listed in
     * increasing order.
     */
    public short[] Next()
    {
        if (isFirst) {
            isFirst = false;
            if (subsetsLevel == setSize) {
                this.hasNext = false;
            }
            return (short[]) subset.clone();
        }

        short index = (short) (subset.length - 1);
        while (subset[index] == setSize + index - subsetsLevel) {
            index--;
        }
        subset[index]++;
	short start = (short)(index+1);
        for (short i = start; i < subsetsLevel; i++) {
            subset[i] = (short) (subset[i-1] + 1);
        }

        if (subset[0] == setSize-subsetsLevel) {
            this.hasNext = false;
        }

        return (short[]) subset.clone();
    }

}
